\environment entorn

\starttext

\startsubject[title={Equacions de primer grau senzilles}]

\startsubsubject[title={Preguntes}]

<%

exercicis = Hash.new

%>

<%# Exercici 1 %>
<%
exercicis[1] = Array.new

for i in (1...5)
  parametres = Hash.new
  parametres['a'] = rand(1..10)
  parametres['b'] = rand(1..10)
  parametres['c'] = rand(1..20)
  exercicis[1].push(parametres)
end
%>

\startexercici[reference=exercici-1] Resoleu les equacions:
\startitemize[a, columns]
<% exercicis[1].each do |par| %>
\item $<%=par['a']%>x + <%=par['b']%> = <%=par['c']%>$
<% end %>
\stopitemize
\stopexercici



<%# Exercici 2 %>
<%
exercicis[2] = Array.new

for i in (1...5)
  parametres = Hash.new
  
  parametres['a'] = rand(-10..10)
  # Evit el cas ax = 0
  if parametres['a'] == 0
     parametres['a'] = -1
  end
  
  parametres['b'] = rand(1..10)
  
  parametres['c'] = rand(-20..20)
  # Evit el cas cx = 0
  if parametres['c'] == 0
     parametres['c'] = 2
  end
  
  parametres['d'] = rand(1..20)
  # Evit el cas de no té solució o infinites solucions
  if parametres['a'] - parametres['c'] == 0
    parametres['a'] = parametres['a'] + 1
  end
  
  exercicis[2].push(parametres)
end
%>


\startexercici[reference=exercici-2] Resoleu les equacions següents:
\startitemize[a, columns]
<% exercicis[2].each do |par| %>
\item $<%=par['a']%>x + <%=par['b']%> = <%=par['c']%>x + <%=par['d']%>$
<% end %>
\stopitemize
\stopexercici



<%# Exercici 3 %>
<%
exercicis[3] = Array.new

for i in (1...7)
  parametres = Hash.new
  
  parametres['a'] = rand(-10..10)
  if parametres['a'] == 0
    parametres['a']=1
  end
  parametres['b'] = rand(1..10)
  parametres['c'] = rand(-20..20)  
  if parametres['c'] == 0
    parametres['c']=1
  end
  parametres['d'] = rand(1..20)
  parametres['e'] = rand(1..20)

  # Evit el cas d'infinites solució o cap solució
  if parametres['b'] - parametres['d'] == 0
    parametres['b'] = parametres['b'] + 1
  end

  
  exercicis[3].push(parametres)
end
%>


\startexercici[reference=exercici-3] Resoleu les equacions següents:
\startitemize[a, columns]
<% exercicis[3].each do |par| %>
\item $<%=par['a']%> + <%=par['b']%>x = <%=par['c']%> + <%=par['d']%>x - <%=par['e']%>$
<% end %>
\stopitemize
\stopexercici

\stopsubsubject

<%# ----------------------- Solucions ------------------------ %>
\page[yes]
\startsubsubject[title={Solucions}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
<% 
   solucio = Rational(par['c']-par['b'],par['a'])
%>
\item $x = \frac{<%=solucio.numerator%>}{<%=solucio.denominator%>}$
<% end %>
\stopitemize

\sym{\in[exercici-2]}
\startitemize[a, text]
<% exercicis[2].each do |par| %>
<% 
   solucio = Rational(par['d']-par['b'],par['a']-par['c'])
%>
\item $x = \frac{<%=solucio.numerator%>}{<%=solucio.denominator%>}$
<% end %>
\stopitemize

\sym{\in[exercici-3]}
\startitemize[a, text]
<% exercicis[3].each do |par| %>
<% 
   solucio = Rational(par['c']-par['e']-par['a'],par['b']-par['d'])
%>
\item $x = \frac{<%=solucio.numerator%>}{<%=solucio.denominator%>}$
<% end %>
\stopitemize

\stopitemize

\vfill
Les solucions d'aquests exercicis s'han calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

<%# ----------------------- Resolució ------------------------ %>
\page[yes]
\startsubsubject[title={Resolució}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   solucio = Rational(c-b,a)
%>

\item $<%=a%>x + <%=b%> = <%=c%>$ $\Rightarrow$ $<%=a%>x = <%=c%> - <%=b%>$ $\Rightarrow$ $x = \frac{<%=c%>-<%=b%>}{<%=a%>}$ $\Rightarrow$ $x = \frac{<%=c - b%>}{<%=a%>}$ $\Rightarrow$ $x = \frac{<%=solucio.numerator%>}{<%=solucio.denominator%>}$
<% end %>
\stopitemize

\sym{\in[exercici-2]}
\startitemize[a, text]
<% exercicis[2].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
   solucio = Rational(d-b,a-c)
%>

\item $<%=a%>x + <%=b%> = <%=c%>x + <%=d%>$ $\Rightarrow$ <% if c < 0 %> $<%=a%>x +<%=c.abs%>x = <%=d%> -<%=b%>$ <% else %> $<%=a%>x -<%=c%>x = <%=d%> -<%=b%>$ <% end %> $\Rightarrow$ $<%=a-c%>x = <%=d-b%>$ $\Rightarrow$ $x = \frac{<%=d-b%>}{<%=a-c%>}$ $\Rightarrow$ $x = \frac{<%=solucio.numerator%>}{<%=solucio.denominator%>}$
<% end %>
\stopitemize

\sym{\in[exercici-3]}
\startitemize[a, text]
<% exercicis[3].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
   e = par['e']
   solucio = Rational(c-e-a,b-d)
%>

\item $<%=a%> + <%=b%>x = <%=c%> + <%=d%>x - <%=e%>$ $\Rightarrow$ $<%=b-d%>x = <%=c-e-a%>$ $\Rightarrow$ $x = \frac{<%=c-e-a%>}{<%=b-d%>} = \frac{<%=solucio.numerator%>}{<%=solucio.denominator%>}$
<% end %>
\stopitemize


\stopitemize

\vfill
La resolució d'aquests exercicis s'ha calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

\stopsubject
\stoptext
